from visual import *
from visual.controls import *



c = controls(title='Choose a Planet!', x=0, y=400, width = 250, height = 250, range=150) # Create controls window
# Create a button in the controls window:
b = button( pos=(0,25), width=60, height=60, text='All')
d = button( pos=(100,25), width=60, height=60, text='Earth')
e = button( pos=(-100,25), width=60, height=60, text='Mars')
f = button( pos=(0,-75), width=60, height=60, text='None')
    
G = 6.7e-11

sun = sphere( pos=(-4e11,0,0), radius=5e10, color=color.yellow, material = materials.rough)
sun.mass = 1.989e30

earth = sphere( pos=(4e11,0,0), radius=1e10, color=color.green, make_trail=True, interval=10, retain=200, material = materials.earth)
earth.mass = 5.972e29
earth.p = 0

mars = sphere( pos=(5e11,0,0), radius=2e10, color=color.red, make_trail=True, interval=10, retain=240)
mars.mass = 6.972e29
mars.p = vector(0,0,1e4) * mars.mass

deltat = 1e5

def Ear():
    if earth.p == 0:
        earth.pos = (4e11,0,0)
        earth.p = vector(0,0,1e4) * earth.mass
        
    while True:
        rate(900)
        
        dist1 = earth.pos - sun.pos
        force1 = G * sun.mass * earth.mass * dist1 / mag(dist1) ** 3
        earth.p = earth.p - force1 * deltat

        earth.pos = earth.pos + earth.p/earth.mass * deltat

def Mar():
    if mars.p == 0:
        mars.pos = (5e11,0,0)
        mars.p = vector(0,0,1e4) * mars.mass

    while True:
        rate(900)
        
        dist2 = mars.pos - sun.pos
        force2 = G * sun.mass * mars.mass * dist2 / mag(dist2) ** 3
        mars.p = mars.p - force2 * deltat

        mars.pos = mars.pos + mars.p/mars.mass * deltat

def All():
    if earth.p == 0:
        earth.pos = (4e11,0,0)
        earth.p = vector(0,0,1e4) * earth.mass

    if mars.p == 0:
        mars.pos = (5e11,0,0)
        mars.p = vector(0,0,1e4) * mars.mass

    while True:
        rate(900)
        
        dist1 = earth.pos - sun.pos
        force1 = G * sun.mass * earth.mass * dist1 / mag(dist1) ** 3
        earth.p = earth.p - force1 * deltat
        
        dist2 = mars.pos - sun.pos
        force2 = G * sun.mass * mars.mass * dist2 / mag(dist2) ** 3
        mars.p = mars.p - force2 * deltat

        for planet in (earth,mars):
            planet.pos = planet.pos + planet.p/planet.mass * deltat
def none():
    while True:
        rate(900)
       
        
d.action = Ear
e.action = Mar
b.action = All
f.action = none
